# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Domsense s.r.l. (<http://www.domsense.com>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import jasper_reports
from osv import osv,fields 
import pooler
import datetime

def jasper_cashflow_parser( cr, uid, ids, data, context ):
    pool = pooler.get_pool(cr.dbname)
    date_start=pool.get('account.fiscalyear').read(cr,uid,data['form']['fiscalyear_id'])['date_start']
    year = date_start[:4]
    return {
        'parameters': {	
            'fiscalyear_id': data['form']['fiscalyear_id'],
            'fiscalyear_name': data['form']['fiscalyear_name'],
            # workaround: without 'or 0.0' the gtk client sends False when initial balance is zero
            'initial_balance_projected': data['form']['initial_balance_projected'] or 0.0,
            'initial_balance_actual': data['form']['initial_balance_actual'] or 0.0,
#            'lingua': data['lang'],
            'company_id': data['form']['company_id'],
            'company_name': data['form']['company_name'],
            'year': year
        },
   }

jasper_reports.report_jasper(
    'report.jasper_operating_cashflow',
    'account.move.line',
    parser=jasper_cashflow_parser
)

jasper_reports.report_jasper(
    'report.jasper_free_cashflow',
    'account.move.line',
    parser=jasper_cashflow_parser
)
