# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 Domsense s.r.l. (<http://www.domsense.com>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class jasper_cashflow_wizard(osv.osv_memory):
    _name='jasper.cashflow.wizard'

    _columns = {
        'fiscalyear_id': fields.many2one('account.fiscalyear', 'Fiscal Year', required=True, select=True),
        'initial_balance_projected': fields.float('Initial balance (projected)', required=True),
        'initial_balance_actual': fields.float('Initial balance (actual)', required=True),
        'free_cashflow': fields.boolean('Free cashflow, includes non-operating cash flow'),
        }
    _defaults = {
        
        ## TODO: Current fiscalyear
        ## TODO: initial balance

        }
    def start_report(self, cr, uid, ids, data, context=None):
        for wiz_obj in self.read(cr,uid,ids):
            if 'form' not in data:
                data['form'] = {}

            company=self.pool.get('res.users').browse(cr,uid,uid,context=context).company_id
            data['form']['company_id'] = company.id
            data['form']['company_name'] = company.name

            fiscalyear=self.pool.get('account.fiscalyear').browse(cr,uid,wiz_obj['fiscalyear_id'],context=context)
            data['form']['fiscalyear_id'] = fiscalyear.id
            data['form']['fiscalyear_name'] = fiscalyear.name

            data['form']['initial_balance_projected'] = wiz_obj['initial_balance_projected']
            data['form']['initial_balance_actual'] = wiz_obj['initial_balance_actual']

            data['model'] = 'account.move.line'
            data['ids']=self.pool.get(data['model']).search(cr,uid,[])

            report_name = 'jasper_free_cashflow' if wiz_obj['free_cashflow'] else 'jasper_operating_cashflow'
            ####
           # data['lang'] = 'en_US'
            ####

            return {
                    'type': 'ir.actions.report.xml',
                    'report_name': report_name,
                    'datas': data,
            }
jasper_cashflow_wizard()