# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class account_voucher(osv.osv):

    _inherit = 'account.voucher'
    _columns = {
        'force_rate': fields.float('Force Rate', digits=(12,6),
            help='The rate of the currency to the currency of rate 1. Use this field to force the voucher to use this rate instead of the system one. Relevant only This field should be used if the payment amount is expressed with a currency that\'s different from the company one, only',
            readonly=True, states={'draft': [('readonly', False)]}),
    }

    def action_move_line_create(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        for voucher in self.browse(cr, uid, ids):
            context['force_currency_rate'] = False
            if voucher.force_rate:
                context['force_currency_rate'] = voucher.force_rate
            res = super(account_voucher, self).action_move_line_create(cr, uid, [voucher.id], context=context)
        return res
        
account_voucher()
