# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import fields, osv

class res_currency(osv.osv):

    _inherit = "res.currency"

    def compute(self, cr, uid, from_currency_id, to_currency_id, from_amount, round=True, context=None):
        if not from_currency_id:
            from_currency_id = to_currency_id
        if not to_currency_id:
            to_currency_id = from_currency_id
        if context is None:
            context = {}
        if not context.get('force_currency_rate', False) or to_currency_id == from_currency_id:
            return super(res_currency, self).compute(
                cr, uid, from_currency_id, to_currency_id, from_amount, round=round, context=context)
        else:
            xc = self.browse(cr, uid, [from_currency_id,to_currency_id], context=context)
            to_currency = self.browse(cr, uid, to_currency_id)
            rate = context['force_currency_rate']
            if round:
                return self.round(cr, uid, to_currency, from_amount * (to_currency.rate / rate))
            else:
                return (from_amount * (to_currency.rate / rate))
                
res_currency()
